// Generated by tools/policy-gen.
// Run "make generate" to update this file.

// nolint:whitespace
package v1alpha1

import (
	_ "embed"
	"fmt"

	"k8s.io/kube-openapi/pkg/validation/spec"
	"sigs.k8s.io/yaml"

	"github.com/kumahq/kuma/pkg/core/resources/model"
)

//go:embed schema.yaml
var rawSchema []byte

func init() {
	var schema spec.Schema
	if rawSchema != nil {
		if err := yaml.Unmarshal(rawSchema, &schema); err != nil {
			panic(err)
		}
	}
	rawSchema = nil
	MeshMultiZoneServiceResourceTypeDescriptor.Schema = &schema
}

const (
	MeshMultiZoneServiceType model.ResourceType = "MeshMultiZoneService"
)

var _ model.Resource = &MeshMultiZoneServiceResource{}

type MeshMultiZoneServiceResource struct {
	Meta   model.ResourceMeta
	Spec   *MeshMultiZoneService
	Status *MeshMultiZoneServiceStatus
}

func NewMeshMultiZoneServiceResource() *MeshMultiZoneServiceResource {
	return &MeshMultiZoneServiceResource{
		Spec:   &MeshMultiZoneService{},
		Status: &MeshMultiZoneServiceStatus{},
	}
}

func (t *MeshMultiZoneServiceResource) GetMeta() model.ResourceMeta {
	return t.Meta
}

func (t *MeshMultiZoneServiceResource) SetMeta(m model.ResourceMeta) {
	t.Meta = m
}

func (t *MeshMultiZoneServiceResource) GetSpec() model.ResourceSpec {
	return t.Spec
}

func (t *MeshMultiZoneServiceResource) SetSpec(spec model.ResourceSpec) error {
	protoType, ok := spec.(*MeshMultiZoneService)
	if !ok {
		return fmt.Errorf("invalid type %T for Spec", spec)
	} else {
		if protoType == nil {
			t.Spec = &MeshMultiZoneService{}
		} else {
			t.Spec = protoType
		}
		return nil
	}
}

func (t *MeshMultiZoneServiceResource) GetStatus() model.ResourceStatus {
	return t.Status
}

func (t *MeshMultiZoneServiceResource) SetStatus(status model.ResourceStatus) error {
	protoType, ok := status.(*MeshMultiZoneServiceStatus)
	if !ok {
		return fmt.Errorf("invalid type %T for Status", status)
	} else {
		if protoType == nil {
			t.Status = &MeshMultiZoneServiceStatus{}
		} else {
			t.Status = protoType
		}
		return nil
	}
}

func (t *MeshMultiZoneServiceResource) Descriptor() model.ResourceTypeDescriptor {
	return MeshMultiZoneServiceResourceTypeDescriptor
}

func (t *MeshMultiZoneServiceResource) Validate() error {
	if v, ok := interface{}(t).(interface{ validate() error }); !ok {
		return nil
	} else {
		return v.validate()
	}
}

var _ model.ResourceList = &MeshMultiZoneServiceResourceList{}

type MeshMultiZoneServiceResourceList struct {
	Items      []*MeshMultiZoneServiceResource
	Pagination model.Pagination
}

func (l *MeshMultiZoneServiceResourceList) GetItems() []model.Resource {
	res := make([]model.Resource, len(l.Items))
	for i, elem := range l.Items {
		res[i] = elem
	}
	return res
}

func (l *MeshMultiZoneServiceResourceList) GetItemType() model.ResourceType {
	return MeshMultiZoneServiceType
}

func (l *MeshMultiZoneServiceResourceList) NewItem() model.Resource {
	return NewMeshMultiZoneServiceResource()
}

func (l *MeshMultiZoneServiceResourceList) AddItem(r model.Resource) error {
	if trr, ok := r.(*MeshMultiZoneServiceResource); ok {
		l.Items = append(l.Items, trr)
		return nil
	} else {
		return model.ErrorInvalidItemType((*MeshMultiZoneServiceResource)(nil), r)
	}
}

func (l *MeshMultiZoneServiceResourceList) GetPagination() *model.Pagination {
	return &l.Pagination
}

func (l *MeshMultiZoneServiceResourceList) SetPagination(p model.Pagination) {
	l.Pagination = p
}

var MeshMultiZoneServiceResourceTypeDescriptor = model.ResourceTypeDescriptor{
	Name:                         MeshMultiZoneServiceType,
	Resource:                     NewMeshMultiZoneServiceResource(),
	ResourceList:                 &MeshMultiZoneServiceResourceList{},
	Scope:                        model.ScopeMesh,
	KDSFlags:                     model.GlobalToAllZonesFlag | model.ZoneToGlobalFlag,
	WsPath:                       "meshmultizoneservices",
	KumactlArg:                   "meshmultizoneservice",
	KumactlListArg:               "meshmultizoneservices",
	AllowToInspect:               false,
	IsPolicy:                     false,
	IsExperimental:               false,
	SingularDisplayName:          "Mesh Multi Zone Service",
	PluralDisplayName:            "Mesh Multi Zone Services",
	IsPluginOriginated:           true,
	IsTargetRefBased:             false,
	HasToTargetRef:               false,
	HasFromTargetRef:             false,
	HasStatus:                    true,
	AllowedOnSystemNamespaceOnly: false,
	IsReferenceableInTo:          true,
}
