// Generated by tools/policy-gen.
// Run "make generate" to update this file.

// nolint:whitespace
package v1alpha1

import (
	_ "embed"
	"errors"
	"fmt"

	"k8s.io/kube-openapi/pkg/validation/spec"
	"sigs.k8s.io/yaml"

	"github.com/kumahq/kuma/pkg/core/resources/model"
)

//go:embed schema.yaml
var rawSchema []byte

func init() {
	var schema spec.Schema
	if rawSchema != nil {
		if err := yaml.Unmarshal(rawSchema, &schema); err != nil {
			panic(err)
		}
	}
	rawSchema = nil
	MeshAccessLogResourceTypeDescriptor.Schema = &schema
}

const (
	MeshAccessLogType model.ResourceType = "MeshAccessLog"
)

var _ model.Resource = &MeshAccessLogResource{}

type MeshAccessLogResource struct {
	Meta model.ResourceMeta
	Spec *MeshAccessLog
}

func NewMeshAccessLogResource() *MeshAccessLogResource {
	return &MeshAccessLogResource{
		Spec: &MeshAccessLog{},
	}
}

func (t *MeshAccessLogResource) GetMeta() model.ResourceMeta {
	return t.Meta
}

func (t *MeshAccessLogResource) SetMeta(m model.ResourceMeta) {
	t.Meta = m
}

func (t *MeshAccessLogResource) GetSpec() model.ResourceSpec {
	return t.Spec
}

func (t *MeshAccessLogResource) SetSpec(spec model.ResourceSpec) error {
	protoType, ok := spec.(*MeshAccessLog)
	if !ok {
		return fmt.Errorf("invalid type %T for Spec", spec)
	} else {
		if protoType == nil {
			t.Spec = &MeshAccessLog{}
		} else {
			t.Spec = protoType
		}
		return nil
	}
}

func (t *MeshAccessLogResource) GetStatus() model.ResourceStatus {
	return nil
}

func (t *MeshAccessLogResource) SetStatus(_ model.ResourceStatus) error {
	return errors.New("status not supported")
}

func (t *MeshAccessLogResource) Descriptor() model.ResourceTypeDescriptor {
	return MeshAccessLogResourceTypeDescriptor
}

func (t *MeshAccessLogResource) Validate() error {
	if v, ok := interface{}(t).(interface{ validate() error }); !ok {
		return nil
	} else {
		return v.validate()
	}
}

var _ model.ResourceList = &MeshAccessLogResourceList{}

type MeshAccessLogResourceList struct {
	Items      []*MeshAccessLogResource
	Pagination model.Pagination
}

func (l *MeshAccessLogResourceList) GetItems() []model.Resource {
	res := make([]model.Resource, len(l.Items))
	for i, elem := range l.Items {
		res[i] = elem
	}
	return res
}

func (l *MeshAccessLogResourceList) GetItemType() model.ResourceType {
	return MeshAccessLogType
}

func (l *MeshAccessLogResourceList) NewItem() model.Resource {
	return NewMeshAccessLogResource()
}

func (l *MeshAccessLogResourceList) AddItem(r model.Resource) error {
	if trr, ok := r.(*MeshAccessLogResource); ok {
		l.Items = append(l.Items, trr)
		return nil
	} else {
		return model.ErrorInvalidItemType((*MeshAccessLogResource)(nil), r)
	}
}

func (l *MeshAccessLogResourceList) GetPagination() *model.Pagination {
	return &l.Pagination
}

func (l *MeshAccessLogResourceList) SetPagination(p model.Pagination) {
	l.Pagination = p
}

var MeshAccessLogResourceTypeDescriptor = model.ResourceTypeDescriptor{
	Name:                         MeshAccessLogType,
	Resource:                     NewMeshAccessLogResource(),
	ResourceList:                 &MeshAccessLogResourceList{},
	Scope:                        model.ScopeMesh,
	KDSFlags:                     model.GlobalToAllZonesFlag | model.ZoneToGlobalFlag | model.GlobalToAllButOriginalZoneFlag,
	WsPath:                       "meshaccesslogs",
	KumactlArg:                   "meshaccesslog",
	KumactlListArg:               "meshaccesslogs",
	AllowToInspect:               true,
	IsPolicy:                     true,
	IsExperimental:               false,
	SingularDisplayName:          "Mesh Access Log",
	PluralDisplayName:            "Mesh Access Logs",
	IsPluginOriginated:           true,
	IsTargetRefBased:             true,
	HasToTargetRef:               true,
	HasFromTargetRef:             true,
	HasStatus:                    false,
	AllowedOnSystemNamespaceOnly: false,
	IsReferenceableInTo:          false,
}
