# Legacy E2E Tests

This package contains legacy E2E tests of Kuma.

Those tests are run sequentially, they don't share Kuma deployment between them.
Executing those tests is very expensive, it is the longest job on the CI.
Adding the tests here potentially slows down the velocity of all contributors.
Please consider writing the test in `e2e_env` directory instead, where all the tests are parallelized on one Kuma deployment.

All the tests are parallelized into multiple VMs. You can control on which VM the test will run using `job-X` label. 
All the tests require `job-X` label, otherwise they won't be run.

## Reasons to write the test in this package over `e2e_env`

* You need to restart the CP/ZoneEgress/ZoneIngress in the test.
* You need to deploy Kuma in very specific way that could break other tests. Examples:
  * lack of Zone Egress
  * default VIPs disabled

## Recommendations

* Use BeforeAll/AfterAll whenever you can. Try not to redeploy Kuma between test cases.
* Take a look at CI and pick a job for your test that finishes first.
* If there is another test that deploys Kuma in the way you want, try to reuse it.


